VERSION 5.00
Begin VB.Form Mainform 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Single Point Acquisition - Internal Clock"
   ClientHeight    =   3540
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   4455
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3540
   ScaleWidth      =   4455
   StartUpPosition =   2  'CenterScreen
   Begin VB.TextBox physicalChannelTextBox 
      Height          =   285
      Left            =   2280
      TabIndex        =   1
      Text            =   "Dev1/ai0"
      Top             =   480
      Width           =   1575
   End
   Begin VB.CommandButton startCommandButton 
      Caption         =   "&Get Voltage"
      Height          =   375
      Left            =   1500
      TabIndex        =   0
      Top             =   3000
      Width           =   1455
   End
   Begin VB.TextBox acquisitionDataTextBox 
      Height          =   285
      Left            =   1440
      Locked          =   -1  'True
      TabIndex        =   8
      TabStop         =   0   'False
      Top             =   2520
      Width           =   1575
   End
   Begin VB.TextBox maxValueTextBox 
      Height          =   285
      Left            =   2280
      TabIndex        =   3
      Text            =   "10.00"
      Top             =   1440
      Width           =   1575
   End
   Begin VB.Frame channelParameterGroupBox 
      Caption         =   "Channel Parameters"
      Height          =   1935
      Left            =   240
      TabIndex        =   4
      Top             =   120
      Width           =   3975
      Begin VB.TextBox minValueTextBox 
         Height          =   285
         Left            =   2040
         TabIndex        =   2
         Text            =   "-10.00"
         Top             =   840
         Width           =   1575
      End
      Begin VB.Label physicalChannelLabel 
         Caption         =   "Physical Channel:"
         Height          =   255
         Left            =   360
         TabIndex        =   5
         Top             =   360
         Width           =   1455
      End
      Begin VB.Label minValueLabel 
         Caption         =   "Minimum Value (V):"
         Height          =   255
         Left            =   360
         TabIndex        =   6
         Top             =   840
         Width           =   1455
      End
      Begin VB.Label maxValueLabel 
         Caption         =   "Maximum Value (V):"
         Height          =   255
         Left            =   360
         TabIndex        =   7
         Top             =   1320
         Width           =   1455
      End
   End
   Begin VB.Label DataLabel 
      Caption         =   "Acquisition Data:"
      Height          =   255
      Left            =   1560
      TabIndex        =   9
      Top             =   2160
      Width           =   1335
   End
End
Attribute VB_Name = "Mainform"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'/*********************************************************************
' Visual Basic 6.0 Example program:
'    SinglePointAcqIntClk.frm
'
' Example Category:
'    AI
'
' Description:
'    This example demonstrates how to acquire a single
'    reading from a constant or slowly varying signal.
'
' Instructions for Running:
'
'   1.  Select the physical channel to correspond to where your signal
'       is input on the DAQ device.
'   2.  Enter the minimum and maximum voltages.
'   Note:  For better accuracy try to match the input range to the
'          expected voltage level of the measured signal.
'
' Steps:
'   1.  Create a new analog input task.
'   2.  Create an analog input voltage channel.
'   3.  Read a single sample from the specified channel.
'   4.  Call the StopTask() module to stop and clear the task.
'
' I/O Connections Overview:
'   Make sure your signal input terminal matches the physical channel
'   control.  In this case wire your signal to the ai0 pin on your
'   DAQ Device.  For more information on the input and output terminals
'   for your device, open the NI-DAQmx Help, and refer to the NI-DAQmx Device
'   Terminals and Device Considerations books in the table of contents.
'
'*********************************************************************/

Option Explicit
    Private data As Double
    Private taskHandle As Long
    Private taskIsRunning As Boolean

Private Sub startCommandButton_Click()
    Dim sampsPerChanRead As Long
    
    On Error GoTo ErrorHandler
    startCommandButton.Enabled = False
    
    If ValidateControlValues Then
        startCommandButton.Enabled = True
        Exit Sub
    End If

    '  Create the DAQmx task.
    DAQmxErrChk DAQmxCreateTask("", taskHandle)
    taskIsRunning = True
    
    '  Add an analog input channel to the task.
    DAQmxErrChk DAQmxCreateAIVoltageChan(taskHandle, physicalChannelTextBox.Text, "", _
                    DAQmx_Val_Cfg_Default, minValueTextBox.Text, maxValueTextBox.Text, _
                    DAQmx_Val_VoltageUnits1_Volts, "")
    
    '  Read in one sample from the analog input channel.
    DAQmxErrChk DAQmxReadAnalogScalarF64(taskHandle, 10#, data, ByVal 0&)
                     
    '  Display the acquired sample on the user interface
    acquisitionDataTextBox.Text = CStr(data)

    '  Call the StopTask module to stop the DAQmx task.
    StopTask
    startCommandButton.Enabled = True
    
    Exit Sub
ErrorHandler:
    If taskIsRunning = True Then
        DAQmxStopTask taskHandle
        DAQmxClearTask taskHandle
        taskIsRunning = False
    End If
        
    startCommandButton.Enabled = True
        
    MsgBox "Error:" & Err.Number & " " & Err.Description, , "Error"
End Sub

Private Sub StopTask()
    '  All done!
    DAQmxErrChk DAQmxStopTask(taskHandle)
    DAQmxErrChk DAQmxClearTask(taskHandle)
    taskIsRunning = False
End Sub

Private Function ValidateControlValues()
    ValidateControlValues = 0
    If minValueTextBox.Text = "" Or maxValueTextBox.Text = "" Then
        MsgBox "Please fill in all empty fields.", , "Error"
        ValidateControlValues = 1
    End If
End Function

Private Sub Form_Load()
    taskIsRunning = False
End Sub

Private Sub Form_Unload(Cancel As Integer)
    '  Quit the program.
    If taskIsRunning = True Then
        StopTask
    End If
    End
End Sub
