VERSION 5.00
Begin VB.Form MainForm 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Count Digital Events"
   ClientHeight    =   3810
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   6285
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3810
   ScaleWidth      =   6285
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox physicalChannelTextBox 
      Height          =   285
      Left            =   2040
      TabIndex        =   3
      Text            =   "Dev1/ctr0"
      Top             =   600
      Width           =   1575
   End
   Begin VB.Frame dataGroupBox 
      Caption         =   "Data"
      Height          =   1335
      Left            =   4320
      TabIndex        =   9
      Top             =   240
      Width           =   1455
      Begin VB.TextBox countTextBox 
         Height          =   285
         Left            =   240
         Locked          =   -1  'True
         TabIndex        =   10
         Text            =   "0"
         Top             =   720
         Width           =   975
      End
      Begin VB.Label countLabel 
         Caption         =   "Count:"
         Height          =   255
         Left            =   240
         TabIndex        =   14
         Top             =   360
         Width           =   735
      End
   End
   Begin VB.Frame channelParameterGroupBox 
      Caption         =   "Channel Parameters"
      Height          =   3255
      Left            =   480
      TabIndex        =   2
      Top             =   240
      Width           =   3615
      Begin VB.Frame edgeGroupBox 
         Caption         =   "Edge"
         Height          =   615
         Left            =   240
         TabIndex        =   6
         Top             =   2280
         Width           =   3135
         Begin VB.OptionButton edgeOptionButton 
            Caption         =   "Falling"
            Height          =   255
            Index           =   1
            Left            =   1800
            TabIndex        =   8
            Top             =   240
            Width           =   855
         End
         Begin VB.OptionButton edgeOptionButton 
            Caption         =   "Rising"
            Height          =   255
            Index           =   0
            Left            =   480
            TabIndex        =   7
            Top             =   240
            Value           =   -1  'True
            Width           =   855
         End
      End
      Begin VB.ComboBox countDirectionComboBox 
         Height          =   315
         ItemData        =   "CountDigEvents.frx":0000
         Left            =   1560
         List            =   "CountDigEvents.frx":000D
         Style           =   2  'Dropdown List
         TabIndex        =   5
         Top             =   1560
         Width           =   1575
      End
      Begin VB.TextBox initialCountTextBox 
         Height          =   285
         Left            =   1560
         TabIndex        =   4
         Text            =   "0"
         Top             =   960
         Width           =   1575
      End
      Begin VB.Label countDirectionLabel 
         Caption         =   "Count Direction:"
         Height          =   255
         Left            =   240
         TabIndex        =   13
         Top             =   1560
         Width           =   1335
      End
      Begin VB.Label initialCountLabel 
         Caption         =   "Initial Count:"
         Height          =   255
         Left            =   240
         TabIndex        =   12
         Top             =   960
         Width           =   975
      End
      Begin VB.Label counterLabel 
         Caption         =   "Counter(s):"
         Height          =   255
         Left            =   240
         TabIndex        =   11
         Top             =   360
         Width           =   1095
      End
   End
   Begin VB.CommandButton stopCommandButton 
      Caption         =   "Stop"
      Height          =   375
      Left            =   4320
      TabIndex        =   1
      Top             =   3120
      Width           =   1455
   End
   Begin VB.CommandButton startCommandButton 
      Caption         =   "Start"
      Height          =   375
      Left            =   4320
      TabIndex        =   0
      Top             =   2640
      Width           =   1455
   End
End
Attribute VB_Name = "MainForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'/*********************************************************************
'*
'* Visual Basic 6.0 Example program:
'*    CountDigEvents.frm
'*
'* Example Category:
'*    CI
'*
'* Description:
'*    This example demonstrates how to count digital events on a
'*    Counter Input Channel. The Initial Count, Count Direction, and
'*    Edge are all configurable.
'*
'*    Edges are counted on the counter's default input terminal (refer
'*    to the I/O Connections Overview section below for more
'*    information), but could easily be modified to count edges on a
'*    PFI or RTSI line.
'*
'* Instructions for Running:
'*    1. Select the Physical Channel which corresponds to the counter
'*       you want to count edges on the DAQ device.
'*    2. Enter the Initial Count, Count Direction, and measurement
'*       Edge to specify how you want the counter to count.
'*       Additionally, you can change the input terminal where events
'*       are counted using the DAQmx Channel attributes.
'*    Note: Use the Gen Dig Pulse Train-Continuous example to verify
'*          that you are counting correctly on the DAQ device.
'*
'* Steps:
'*    1. Create a task.
'*    2. Create a Counter Input channel to Count Events. The Edge
'*       parameter is used to determine if the counter will increment
'*       on rising or falling edges.
'*    3. Call the DAQmxStartTask function to arm the counter and begin
'*       counting. The counter will be preloaded with the Initial
'*       Count.
'*    4. The counter will be continually polled until the Stop button
'*       is pressed on the front panel.
'*    5. Call the StopTask() module to stop and clear the Task.
'*    6. Display an error if any.
'*
'* I/O Connections Overview:
'*    The counter will count edges on the input terminal of the
'*    counter specified in the Physical Channel I/O control.
'*
'*    In this example the counter will count edges on the default
'*    input terminal on ctr0.
'*
'*    For more information on the default counter input and output
'*    terminals for your device, open the NI-DAQmx Help, and refer to
'*    Counter Signal Connections found under the Device Considerations
'*    book in the table of contents.
'*
'*********************************************************************/

Option Explicit
    Private taskHandle As Long
    Private taskIsRunning As Boolean

Private Sub startCommandButton_Click()
    Dim edge As Long
    Dim countDirection As Long
    Dim data As Double
    
    On Error GoTo ErrorHandler
    
    startCommandButton.Enabled = False
    stopCommandButton.Enabled = True
    
    If ValidateControlValues Then
        startCommandButton.Enabled = True
        stopCommandButton.Enabled = False
        Exit Sub
    End If
    
    If edgeOptionButton(0) = True Then
        edge = DAQmx_Val_Edge1_Rising
    Else
        edge = DAQmx_Val_Edge1_Falling
    End If
    
    If countDirectionComboBox.Text = "Count Up" Then
        countDirection = DAQmx_Val_CountDirection1_CountUp
    ElseIf countDirectionComboBox.Text = "Count Down" Then
        countDirection = DAQmx_Val_CountDirection1_CountDown
    ElseIf countDirectionComboBox.Text = "Externally Controlled" Then
        countDirection = DAQmx_Val_CountDirection1_ExtControlled
    End If
     
    ' Create the DAQmx task.
    DAQmxErrChk DAQmxCreateTask("", taskHandle)
    taskIsRunning = True
    
    ' Add a counter input channel to the task.
    DAQmxErrChk DAQmxCreateCICountEdgesChan(taskHandle, physicalChannelTextBox.Text, "", _
    edge, initialCountTextBox.Text, countDirection)
    
    ' Start the task running, and read from the counter channel
    DAQmxErrChk DAQmxStartTask(taskHandle)
    
    While taskIsRunning = True
        ' Read in samples from the counter input.
        DAQmxErrChk DAQmxReadCounterScalarF64(taskHandle, 10#, data, ByVal 0&)
        
        ' Display the acquired sample on the Mainform.
        countTextBox.Text = Conversion.CStr(data)
        DoEvents
    Wend
    
    startCommandButton.Enabled = True
    stopCommandButton.Enabled = False
    
    Exit Sub
    
ErrorHandler:
    If taskIsRunning = True Then
        DAQmxStopTask taskHandle
        DAQmxClearTask taskHandle
        taskIsRunning = False
    End If
    
    startCommandButton.Enabled = True
    stopCommandButton.Enabled = False
                
    MsgBox "Error: " & Err.Number & " " & Err.Description, , "Error"
End Sub

Private Sub stopCommandButton_Click()
    StopTask
End Sub

Private Sub StopTask()
    ' Stop the DAQmx task.
    DAQmxErrChk DAQmxStopTask(taskHandle)
    DAQmxErrChk DAQmxClearTask(taskHandle)
    taskIsRunning = False
End Sub

Private Function ValidateControlValues()
    ValidateControlValues = 0
    
    If physicalChannelTextBox.Text = "" Or initialCountTextBox.Text = "" Then
        MsgBox "Please fill in all empty fields.", , "Error"
        ValidateControlValues = 1
    End If
End Function

Private Sub Form_Load()
    taskIsRunning = False
    stopCommandButton.Enabled = False
    countDirectionComboBox.ListIndex = 0
End Sub

Private Sub Form_Unload(Cancel As Integer)
  'Quit the program.
    If taskIsRunning = True Then
        StopTask
    End If
    End
End Sub


