VERSION 5.00
Begin VB.Form MainForm 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Continuous Pulse Train"
   ClientHeight    =   5490
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   3285
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   5490
   ScaleWidth      =   3285
   StartUpPosition =   2  'CenterScreen
   Begin VB.TextBox physicalChannelTextBox 
      Height          =   285
      Left            =   720
      TabIndex        =   3
      Text            =   "Dev1/ctr0"
      Top             =   840
      Width           =   1695
   End
   Begin VB.CommandButton stopCommandButton 
      Caption         =   "&Stop"
      Height          =   375
      Left            =   840
      TabIndex        =   1
      Top             =   4920
      Width           =   1455
   End
   Begin VB.Frame channelParameterGroupBox 
      Caption         =   "Channel Parameters"
      Height          =   3735
      Left            =   240
      TabIndex        =   2
      Top             =   120
      Width           =   2775
      Begin VB.Frame idleStateGroupBox 
         Caption         =   "Idle State"
         Height          =   855
         Left            =   240
         TabIndex        =   6
         Top             =   2640
         Width           =   2175
         Begin VB.OptionButton idleStateOptionButton 
            Caption         =   "High"
            Height          =   195
            Index           =   1
            Left            =   1200
            TabIndex        =   8
            Top             =   360
            Width           =   735
         End
         Begin VB.OptionButton idleStateOptionButton 
            Caption         =   "Low"
            Height          =   195
            Index           =   0
            Left            =   240
            TabIndex        =   7
            Top             =   360
            Value           =   -1  'True
            Width           =   615
         End
      End
      Begin VB.TextBox frequencyTextBox 
         Height          =   285
         Left            =   480
         TabIndex        =   4
         Text            =   "1.50"
         Top             =   1440
         Width           =   1695
      End
      Begin VB.TextBox dutyCycleTextBox 
         Height          =   285
         Left            =   480
         TabIndex        =   5
         Text            =   "50.00"
         Top             =   2160
         Width           =   1695
      End
      Begin VB.Label physicalChannelLabel 
         Caption         =   "Counter(s):"
         Height          =   255
         Left            =   480
         TabIndex        =   10
         Top             =   480
         Width           =   975
      End
      Begin VB.Label frequencyLabel 
         Caption         =   "Frequency (Hz):"
         Height          =   255
         Left            =   480
         TabIndex        =   11
         Top             =   1200
         Width           =   1215
      End
      Begin VB.Label dutyCycleLabel 
         Caption         =   "Duty Cycle (%):"
         Height          =   255
         Left            =   480
         TabIndex        =   12
         Top             =   1920
         Width           =   1095
      End
   End
   Begin VB.CommandButton startCommandButton 
      Caption         =   "&Start"
      Height          =   375
      Left            =   840
      TabIndex        =   0
      Top             =   4440
      Width           =   1455
   End
   Begin VB.Label generatingLabel 
      Height          =   255
      Left            =   240
      TabIndex        =   9
      Top             =   3960
      Visible         =   0   'False
      Width           =   2775
   End
End
Attribute VB_Name = "MainForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'/*********************************************************************
'*
'* Visual Basic 6.0 Example program:
'*    ContDigPulseTrain.frm
'*
'* Example Category:
'*    CO
'*
'* Description:
'*    This example demonstrates how to generate a continuous digital
'*    pulse train from a Counter Output Channel. The Frequency, Duty
'*    Cycle, and Idle State are all configurable.
'*
'*    This example shows how to configure the pulse in terms of
'*    Frequency/Duty Cycle, but can easily be modified to generate a
'*    pulse in terms of Time or Ticks.
'*
'* Instructions for Running:
'*    1. Select the Physical Channel which corresponds to the counter
'*       you want to output your signal to on the DAQ device.
'*    2. Enter the Frequency and Duty Cycle to define the pulse
'*       parameters. You can also change the Idle State to determine
'*       the beginning and end states of the output. If the Idle State
'*       is High, the generation will use inverted logic.
'*       Additionally, you can set the Initial Delay (in seconds)
'*       which will delay the beginning of the pulse train from the
'*       start call; this is currently set to 0.0 in the code.
'
'*    Note: Use the Measure Period example to verify you are
'*          outputting the pulse train on the DAQ device.
'*
'* Steps:
'*    1. Create a task.
'*    2. Create a Counter Output channel to produce a Pulse in terms
'*       of Frequency. If the Idle State of the pulse is set to low,
'*       the state of the line will begin low and remain low after the
'*       generation is stopped.
'*    3. Call the timing function to configure the duration of the
'*       pulse generation.
'*    4. Call the Start function to arm the counter and begin the
'*       pulse
'*    train generation.
'*    5. For continuous generation, the counter will continually
'*       generate the pulse train until stop button is pressed.
'*    6. Call the Clear Task function to clear the Task.
'*    7. Display an error if any.
'*
'* I/O Connections Overview:
'*    The counter will output the pulse train on the output terminal
'*    of the counter specified in the Physical Channel I/O control.
'*
'*    In this example the output will be sent to the default output
'*    terminal on ctr0.
'*
'*    For more information on the default counter input and output
'*    terminals for your device, open the NI-DAQmx Help, and refer to
'*    Counter Signal Connections found under the Device Considerations
'*    book in the table of contents.
'*
'*********************************************************************/

Option Explicit
    Private taskHandle As Long
    Private taskIsRunning As Boolean

Private Sub startCommandButton_Click()
    Dim sampsPerChanRead As Long
    Dim idleState As Long
    Dim numSampsPerChannel As Long
    
    On Error GoTo ErrorHandler
    
    startCommandButton.Enabled = False
    stopCommandButton.Enabled = True
    
    If ValidateControlValues Then
        startCommandButton.Enabled = True
        stopCommandButton.Enabled = False
        Exit Sub
    End If
    
    numSampsPerChannel = 100
    
    If idleStateOptionButton(0) = True Then
        idleState = DAQmx_Val_Level1_Low
    Else
        idleState = DAQmx_Val_Level1_High
    End If
    
    '  Create the DAQmx task.
    DAQmxErrChk DAQmxCreateTask("", taskHandle)
    taskIsRunning = True
    
    'Create Counter Channel for pulse generation
    DAQmxErrChk DAQmxCreateCOPulseChanFreq(taskHandle, physicalChannelTextBox.Text, "coChannel", DAQmx_Val_FrequencyUnits2_Hz, idleState, _
                         0#, Conversion.CDbl(frequencyTextBox.Text), Conversion.CDbl(dutyCycleTextBox.Text / 100))
                         
    'Specify continuous timing
    DAQmxErrChk DAQmxCfgImplicitTiming(taskHandle, DAQmx_Val_AcquisitionType_ContSamps, numSampsPerChannel)

    'Start generating the pulse train
    DAQmxStartTask (taskHandle)
    generatingLabel.Caption = "Generating..."
    generatingLabel.Visible = True
    stopCommandButton.Enabled = True
    
    Exit Sub
    
ErrorHandler:
    If taskIsRunning = True Then
        DAQmxStopTask taskHandle
        DAQmxClearTask taskHandle
        taskIsRunning = False
    End If
                
    generatingLabel.Visible = False
    startCommandButton.Enabled = True
    stopCommandButton.Enabled = False
                
    MsgBox Err.Number & " " & Err.Description, , "Error"
End Sub

Private Sub stopCommandButton_Click()
    StopTask
    generatingLabel.Visible = False
    stopCommandButton.Enabled = False
    startCommandButton.Enabled = True
End Sub

Private Sub StopTask()
    '  Stop the DAQmx task.
    If taskIsRunning = True Then
        DAQmxErrChk DAQmxStopTask(taskHandle)
        DAQmxErrChk DAQmxClearTask(taskHandle)
        taskIsRunning = False
    End If
End Sub

Private Function ValidateControlValues()
    ValidateControlValues = 0
    
    If frequencyTextBox.Text = "" Or dutyCycleTextBox.Text = "" Then
        MsgBox "Please fill in the empty fields.", , "Error"
        ValidateControlValues = 1
    End If
End Function

Private Sub Form_Load()
    taskIsRunning = False
    stopCommandButton.Enabled = False
End Sub
    
Private Sub Form_Unload(Cancel As Integer)
    ' Quit the program.
    generatingLabel.Visible = False
    If taskIsRunning = True Then
        StopTask
    End If
    End
End Sub


